//interface generique 
//On suppose que COEFF est defini qqupart sinon 
// on ecrit de fonction pour rien
#ifndef HAS_GENERIC_DEFINED
#define HAS_GENERIC_DEFINED

#define glue(o,p) o ## p
#define xglue(o,p) glue(o,p)
#define triglue(a,b,c) a ## b ## c
#define xtriglue(a,b,c) triglue(a,b,c)

/*
 *
 *Type definition
 *
 */
#define __mpai_struct xtriglue(__mpai_,PREFIX,_struct) 
#define mpai_t xtriglue(mpai_,PREFIX,_t)
#define mpai_ptr xtriglue(mpai_,PREFIX,_ptr)
#define mpai_srcptr xtriglue(mpai_,PREFIX,_srcptr)
#define mpai_rep xtriglue(mpai_,PREFIX,_rep)
#define mpai xglue(mpai_,PREFIX)
#define mpai_const xtriglue(mpai_,PREFIX,_const)
#define mpai_ref xtriglue(mpai_,PREFIX,_ref)
#define mpai_prec xtriglue(mpai_,PREFIX,_prec)
#define mpai_nbmul xtriglue(mpai_,PREFIX,_nbmul)
/*something else */

#define gen_init  xglue(PREFIX,_init)
#define gen_clear xglue(PREFIX,_clear)
#define gen_set xglue(PREFIX,_set)
#define gen_init_set xglue(PREFIX,_init_set)
#define gen_set_d xglue(PREFIX,_set_d)
#define gen_set_si xglue(PREFIX,_set_si)
#define gen_mul_d xglue(PREFIX,_mul_d)
#define gen_add mpai_nbmul++,xglue(PREFIX, _add)
#define gen_sub mpai_nbmul++,xglue(PREFIX, _sub)
#define gen_mul mpai_nbmul++,xglue(PREFIX, _mul)
#define gen_div xglue(PREFIX,_div)
#define gen_neg xglue(PREFIX, _neg)
#define gen_out_stream xglue(PREFIX,_out_stream)
#define gen_cmp xglue(PREFIX,_cmp)
#define gen_sgn xglue(PREFIX,_sgn)



#define mpai_init xtriglue(mpai_,PREFIX,_init)
#define mpai_clear xtriglue(mpai_,PREFIX,_clear)
#define mpai_set_prec xtriglue(mpai_,PREFIX,_set_prec)
#define mpai_set_d xtriglue(mpai_,PREFIX,_set_d)
#define mpai_set_si xtriglue(mpai_,PREFIX,_set_si)
#define mpai_mul_d xtriglue(mpai_,PREFIX,_mul_d)
#define mpai_div_d xtriglue(mpai_,PREFIX,_div_d)
#define mpai_set xtriglue(mpai_,PREFIX,_set)
#define mpai_add xtriglue(mpai_,PREFIX,_add)
#define mpai_sub xtriglue(mpai_,PREFIX,_sub)
#define mpai_mul xtriglue(mpai_,PREFIX,_mul)
#define mpai_div xtriglue(mpai_,PREFIX,_div)
#define mpai_out_str xtriglue(mpai_,PREFIX,_out_str)
#define mpai_mul_eps xtriglue(mpai_,PREFIX,_mul_eps)
#define mpai_cmp xtriglue(mpai_,PREFIX,_cmp)
#define mpai_isNull xtriglue(mpai_,PREFIX,_isNull)
#define mpai_isPos xtriglue(mpai_,PREFIX,_isPos)
#define mpai_isNeg xtriglue(mpai_,PREFIX,_isNeg)
#define mpai_isUnit xtriglue(mpai_,PREFIX,_isUnit)
#define mpai_isEq xtriglue(mpai_,PREFIX,_isEq)
#define mpai_exactdiv xtriglue(mpai_,PREFIX,_exactdiv)
#define mpai_addmul xtriglue(mpai_,PREFIX,_addmul)
#define mpai_submul xtriglue(mpai_,PREFIX,_submul)
#define mpai_comb xtriglue(mpai_,PREFIX,_comb)
#define mpai_neg xtriglue(mpai_,PREFIX,_neg)
#define mpai_inv xtriglue(mpai_,PREFIX,inv)
#define mpai_pow xtriglue(mpai_,PREFIX,_pow)
#define mpai_gcd xtriglue(mpai_,PREFIX,_gcd)
#define mpai_rem xtriglue(mpai_,PREFIX,_rem)
#define mpai_lcm xtriglue(mpai_,PREFIX,_lcm)
#define mpai_mod xtriglue(mpai_,PREFIX,_mod)
#define mpai_dadd xtriglue(mpai_,PREFIX,_dadd)
#define mpai_dsub xtriglue(mpai_,PREFIX,_dsub)
#define mpai_dmul xtriglue(mpai_,PREFIX,_dmul)
#define mpai_ddiv xtriglue(mpai_,PREFIX,_ddiv)
#define mpai_dexactdiv xtriglue(mpai_,PREFIX,_dexactdiv)
#define mpai_daddmul xtriglue(mpai_,PREFIX,_daddmul)
#define mpai_dsubmul xtriglue(mpai_,PREFIX,_dsubmul)
#define mpai_dcomb xtriglue(mpai_,PREFIX,_dcomb)
#define mpai_dneg xtriglue(mpai_,PREFIX,_dneg)
#define mpai_dinv xtriglue(mpai_,PREFIX,_dinv)
#define mpai_dpow xtriglue(mpai_,PREFIX,_dpow)
#define mpai_dgcd xtriglue(mpai_,PREFIX,_dgcd)
#define mpai_drem xtriglue(mpai_,PREFIX,_drem)
#define mpai_dlcm xtriglue(mpai_,PREFIX,_dlcm)
#define mpai_cmp_ui xtriglue(mpai_,PREFIX,_cmp_ui)
#define mpai_karatsuba_mul xtriglue(mpai_,PREFIX,_karatsuba_mul)
#define mpai_karatsuba_under_mul xtriglue(mpai_,PREFIX,_karatsuba_under_mul)
#define mpai_short_prod xtriglue(mpai_,PREFIX,_short_prod)
#define mpai_nonewton_div xtriglue(mpai_,PREFIX,_nonewton_div)

#define set_cont xglue(PREFIX,_set_cont)
#define add_cont xglue(PREFIX,_add_cont)
#define sub_cont xglue(PREFIX,_sub_cont)
#define mul_cont xglue(PREFIX,_mul_cont)
#define div_cont xglue(PREFIX,_div_cont)
#define mul_cont_d xglue(PREFIX,_mul_cont_d)
#define set_cont_i xglue(PREFIX,_set_cont_i)
#define set_cont_d xglue(PREFIX,_set_cont_d)

#endif
