#line 1 "cob.h"

#ifndef _rs_inf_br_cob_h
#define _rs_inf_br_cob_h

typedef inf_br_rep inf_br[1];
typedef inf_br_rep * inf_br_ref;
typedef const inf_br_rep * inf_br_const;

#define inf_br_p2t(a) (a)          
#define inf_br_t2p(a) (a)          
#define inf_br_rep2t(a) (&(a))       
#define inf_br_t2rep(a) (*(a))       
#define inf_br_rep2p(a) (&(a))       
#define inf_br_p2rep(a) (*(a))      
#define inf_br_ref2t(a) (a)       
#define inf_br_t2ref(a) (a)       
#define inf_br_ref2p(a) (a)       
#define inf_br_p2ref(a) (a)      
#define inf_br_ref2rep(a) (*(a))       
#define inf_br_rep2ref(a) (&(a))      
#define inf_br_need_init 1

RS_EXPORT void      inf_br_init(inf_br_ref);
RS_EXPORT void      inf_br_init_c(inf_br_ref,inf_br_const);
RS_EXPORT void      inf_br_set_c(inf_br_ref,inf_br_const);

RS_EXPORT RS_I16    inf_br_cmp(inf_br_const,inf_br_const);

RS_EXPORT inf_br_rep * inf_br_copy_rep(inf_br_const);
RS_EXPORT inf_br *     inf_br_copy(inf_br_const);

#define inf_br_new_rep(nb)  ((inf_br_rep *) RSALLOC(nb*sizeof(inf_br_rep)))
#define inf_br_new(nb)  ((inf_br *) RSALLOC(nb*sizeof(inf_br)))
#define inf_br_new_rep_1()  ((inf_br_rep *) RSALLOC(sizeof(inf_br_rep)))
#define inf_br_new_1()  ((inf_br *) RSALLOC(sizeof(inf_br)))
#define inf_br_rcopy(a,b) (a[0]=b[0])


RS_EXPORT void      inf_br_in(inf_br_ref,FILE *);
RS_EXPORT void      inf_br_out(inf_br_const,FILE *);

RS_EXPORT void      inf_br_set_root(inf_br_ref);
RS_EXPORT RS_BOOL   inf_br_read_buff(rs_buff_in_ref,inf_br_ref);

#endif
